﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.01
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim SensorsMap As Map
	Type SensorData (Name As String, ThreeValues As Boolean)

	Dim SensorsLabels As Map
	Dim Acel_x, Acel_y, Acel_z As Float

	Dim LVal0, LVal1, LVal2 As Float

	Dim Cnt_X, Cnt_X1, Cnt_y, Cnt_Y1, cnt_Z, Cnt_Z1 As Int
	Dim xFlag_X, xFlag_Y, xFlag_Z As Boolean
	Dim PhV As PhoneVibrate
	Dim Timer_Shake As Timer
	Dim f_foreground, f_sensor_change As Boolean

	Dim const Limit = 4 As Int
	Dim const Limit_1 = 1 As Int
	Dim const Limit_Y = -2 As Int
	Dim const Limit_Y1 = -7 As Int

	
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

	Timer_Shake.Initialize("Timer_Shake",2200)
	Timer_Shake.Enabled = False

End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
	f_foreground = False
	LVal0 = 0
	LVal1 = 0
	LVal2 = 0
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
	For i = 0 To SensorsMap.Size - 1
		Dim ps As PhoneSensors
		ps = SensorsMap.GetKeyAt(i)
		ps.StopListening
	Next
	ToastMessageShow("Registro TXT DESactivado",False)
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub


'Public Sub AddSensor(SensorType As Int, Name As String, ThreeValues As Boolean)  ' As SensorData
Sub AddSensor(SensorType As Int, Name As String)  ' As SensorData
	Dim sd As SensorData
	sd.Initialize
	sd.Name = Name
	sd.ThreeValues = True 'ThreeValues
	Dim ps As PhoneSensors
	ps.Initialize(SensorType)
	SensorsMap.Put(ps, sd)
	Log(Name & " MaxValue = " & ps.MaxValue)
'	ps.StartListening("Sensor")
	If ps.StartListening("Sensor") = False Then
		Log(sd.Name & " is not supported.")
	End If
End Sub


Sub Sensor_SensorChanged (Values() As Float)
	Dim ps As PhoneSensors
	Dim sd As SensorData
	Dim lbl As Label
	
	'Get the PhoneSensors object that raised this event.
	ps = Sender
	sd = SensorsMap.Get(ps) 'Get the associated SensorData obejct
	If f_foreground Then
		lbl = SensorsLabels.Get(ps) 'Get the associated Label.
	End If

'	Log ( sd.Name)
	If sd.Name = "Heart" Then
		Log ( "*** Heart: " & Values(0) )
		If f_foreground Then
			lbl.Text = sd.Name & " teste  = " &  Values(0)  ' NumberFormat(Values(0), 0, 3)
		End If	
	Else
		If f_sensor_change = False Then
			f_sensor_change= True
		
'			Log ( "Val0 Delta: " & Abs (LVal0 -	Values(0) ) )
'			If Abs (LVal0 -	Values(0) ) > 0.5 Then
'				Log ( "Val0 : " & Values(0) )
'				LVal0 = Values(0)
'				If xFlag_X Then    'True Verifica > 2000
'					If Values(0) > Limit Then
'						If Cnt_X = 0 Then
'							Timer_Shake.Enabled = True
'						End If
'						Cnt_X = Cnt_X+1
'						Log ( "Cnt_X: " & Cnt_X )
'						If Cnt_X > 2 And Cnt_X1 > 2 Then
'							Vibra						
'							Cnt_X = 0
'							Cnt_X1 = 0
'							Timer_Shake.Enabled = False
'						End If
'						xFlag_X = False
'					End If
'				Else
'					If Values(0) < Limit_1 Then
'						Cnt_X1 = Cnt_X1+1
'						Log ( "Cnt_X1: " & Cnt_X1)
'						Log ( "**********************")
'						If Cnt_X > 2 And Cnt_X1 > 2 Then
'							Vibra
'							Cnt_X = 0
'							Cnt_X1 = 0
'							Timer_Shake.Enabled = False
'						End If
'						xFlag_X = True
'					End If
'					
'				End If
'			End If

			'Log ( "Val1 Delta: " & Abs (LVal1 -	Values(1) ) )

			If Abs (LVal1 -	Values(1) ) > 4 Then
				
				If  Values(2) > 7 Then
					If xFlag_Y Then    'True Verifica > 2000
						If Values(1) > Limit_Y Then
							Log ( "Val1 : " & Values(1) )
							LVal1 = Values(1)
							If Cnt_y = 0 Then
								Timer_Shake.Enabled = True
							End If
							Cnt_y = Cnt_y+1
							Log ( "Cnt_Y: " & Cnt_y )
							If Cnt_y > 2 And Cnt_Y1 > 2 Then
								LVal1 = 0
								Cnt_y = 0
								Cnt_Y1 = 0
								Timer_Shake.Enabled = False
								Vibra
							End If
							xFlag_Y = False
						End If
					Else
						If Values(1) < Limit_Y1 Then
							Log ( "Val1 : " & Values(1) )
							LVal1 = Values(1)
							Cnt_Y1 = Cnt_Y1+1
							Log ( "Cnt_Y1: " & Cnt_Y1)
							Log ( "**********************")
							If Cnt_y > 2 And Cnt_Y1 > 2 Then
								LVal1 = 0
								Cnt_y = 0
								Cnt_Y1 = 0
								Timer_Shake.Enabled = False
								Vibra
							End If
							xFlag_Y = True
						End If
					End If
				End If

			End If

''Giroscopio
'			If Abs(Values(0)) > 2 Or Abs(Values(1)) > 2 Or Abs(Values(2)) > 2 Then
'				Log ( "val0: " & Values(0) )
'				Log ( "val1: " & Values(1) )
'				Log ( "val2: " & Values(2) )
'				Log ( "****************" )
'			End If
		End If
		
		If f_foreground Then
			If sd.ThreeValues Then
				lbl.Text = sd.Name & " X=" & NumberFormat(Values(0), 0, 3) & ", Y=" & NumberFormat(Values(1), 0, 3) _
				& ", Z=" & NumberFormat(Values(2), 0, 3)
			Else
				lbl.Text = sd.Name & " = " &  Values(0) ' NumberFormat(Values(0), 0, 3)
			End If
		End If
		f_sensor_change = False
	End If
End Sub

Sub Vibra
	PhV.Vibrate ( 500)
	Sleep( 300)
	PhV.Vibrate ( 500)
	ToastMessageShow ("Alarme", True)	
End Sub
Sub Service_Destroy
	For i = 0 To SensorsMap.Size - 1
		Dim ps As PhoneSensors
		ps = SensorsMap.GetKeyAt(i)
		ps.StopListening
	Next
	Timer_Shake.Enabled = False
End Sub

Sub Timer_Shake_Tick
	Cnt_X = 0
	Cnt_X1 = 0
	Cnt_y = 0
	Cnt_Y1 = 0
	Log ( "Reset" )
	Timer_Shake.Enabled = False
End Sub

