﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Bateria
	Dim Pe As PhoneEvents
	Dim Last_Level As Int = 0
	Dim Last_Plugged As  Boolean = False
	Dim n As Notification
	Dim PhWs As PhoneWakeState

End Sub

Sub Service_Create
	n = CreateNotification ("SOS App", "Bateria" & "...", "icon", "Main", False, False)
	Service.StartForeground(1,n)
'	Service.AutomaticForegroundMode =  Service.AUTOMATIC_FOREGROUND_ALWAYS

	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
'	StartServiceAt(Me, DateTime.Now + 0.5 * DateTime.TicksPerMinute, True)
	Pe.Initialize ("PE")
Log ( "Iniciou bateria")

End Sub

Sub Service_Start (StartingIntent As Intent)
	PhWs.PartialLock
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

Sub Service_Destroy

End Sub


Sub PE_BatteryChanged(Level As Int, Scale As Int, Plugged As Boolean, Intent As Intent)
	'it seem that this event is called also when there aren't changes, almost when plugged,
	'save some battery by checking for changes...
	Dim xResp As String
		
	xResp = ""	
	If Level <> Last_Level Then
		Last_Level = Level
		Log ( "Bateria : " & Level )
		xResp =  "Bateria : " & Level
	End If
	If Plugged <> Last_Plugged Then
		Last_Plugged = Plugged
		Log  ( "Carregador Conectado: " & Plugged )
		xResp = xResp &  " - Carregador Conectado: " & Plugged
	End If

	If xResp.Length > 0 Then
		ToastMessageShow ( xResp , False)
	Else
		ToastMessageShow ("leu Bateria",False)	
	End If

Log ( "leu bateria " & xResp)
	PhWs.ReleasePartialLock
	Pe.StopListening
'	n.Cancel(1)
	StopService (Me)
End Sub

Private  Sub CreateNotification(Title As String, Content As String, Icon As String, TargetActivity As Object, _
    Sound As Boolean, Vibrate As Boolean) As Notification
	Dim p As Phone
	Dim sChannelName As String
'	If Sound Then
'		sChannelName = "MyChannelId1"
'	Else
'		sChannelName = "MyChannelId2"
'	End If

	If p.SdkVersion >= 21 Then
		Dim nb As NotificationBuilder
		nb.Initialize
		nb.DefaultSound = Sound
		nb.DefaultVibrate = Vibrate
		nb.ContentTitle = Title
		nb.ContentText = Content
		nb.AutoCancel = True
		nb.setActivity(TargetActivity)
		nb.SmallIcon = Icon
		If p.SdkVersion >= 26 Then
			Dim ctxt As JavaObject
			ctxt.InitializeContext
			Dim managerJ As JavaObject
			managerJ.InitializeStatic("android.app.NotificationmanagerJ")
			Dim Channel As JavaObject
			Dim importance As String
			If Sound Then importance = "IMPORTANCE_DEFAULT" Else importance = "IMPORTANCE_NONE" '"IMPORTANCE_LOW"
			Dim ChannelVisibleName As String = Application.LabelName
			Channel.InitializeNewInstance("android.app.NotificationChannel", _
                   Array(sChannelName, ChannelVisibleName, managerJ.GetField(importance)))
			managerJ = ctxt.RunMethod("getSystemService", Array("notification"))
			managerJ.RunMethod("createNotificationChannel", Array(Channel))
			Dim jo As JavaObject = nb
'			jo.RunMethod("setChannelId", Array(sChannelName))
		End If
		Return  nb.GetNotification
	Else
		Dim n As Notification
		n.Initialize
		n.Sound = False
		n.Vibrate = Vibrate
		n.AutoCancel = True
		n.Icon = Icon
		n.SetInfo(Title, Content, TargetActivity)
		Return n
	End If
End Sub

